- [HTTP request](https://docs.cloud.google.com/compute/docs/reference/rest/beta/routers/getNatMappingInfo#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/compute/docs/reference/rest/beta/routers/getNatMappingInfo#body.PATH_PARAMETERS)
- [Query parameters](https://docs.cloud.google.com/compute/docs/reference/rest/beta/routers/getNatMappingInfo#body.QUERY_PARAMETERS)
- [Request body](https://docs.cloud.google.com/compute/docs/reference/rest/beta/routers/getNatMappingInfo#body.request_body)
- [Response body](https://docs.cloud.google.com/compute/docs/reference/rest/beta/routers/getNatMappingInfo#body.response_body)
  - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/beta/routers/getNatMappingInfo#body.VmEndpointNatMappingsList.SCHEMA_REPRESENTATION)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/beta/routers/getNatMappingInfo#body.VmEndpointNatMappingsList.SCHEMA_REPRESENTATION.item.SCHEMA_REPRESENTATION)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/beta/routers/getNatMappingInfo#body.VmEndpointNatMappingsList.SCHEMA_REPRESENTATION.warning.SCHEMA_REPRESENTATION)
- [Authorization scopes](https://docs.cloud.google.com/compute/docs/reference/rest/beta/routers/getNatMappingInfo#body.aspect)
- [IAM Permissions](https://docs.cloud.google.com/compute/docs/reference/rest/beta/routers/getNatMappingInfo#body.aspect_1)
- [Try it!](https://docs.cloud.google.com/compute/docs/reference/rest/beta/routers/getNatMappingInfo#try-it)

Retrieves runtime Nat mapping information of VM endpoints.

### HTTP request

Choose an endpoint:
global africa-south1 asia-east1 asia-east2 asia-northeast1 asia-northeast2 asia-northeast3 asia-south1 asia-south2 asia-southeast1 asia-southeast2 asia-southeast3 australia-southeast1 australia-southeast2 europe-central2 europe-north1 europe-north2 europe-southwest1 europe-west1 europe-west10 europe-west12 europe-west2 europe-west3 europe-west4 europe-west6 europe-west8 europe-west9 me-central1 me-central2 me-west1 northamerica-northeast1 northamerica-northeast2 northamerica-south1 southamerica-east1 southamerica-west1 us-central1 us-east1 us-east4 us-east5 us-south1 us-west1 us-west2 us-west3 us-west4   
`GET https://compute.googleapis.com/compute/beta/projects/{project}/regions/{region}/routers/{router}/getNatMappingInfo`

<br />

The URLs use [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `project` | `string` Project ID for this request. |
| `region` | `string` Name of the region for this request. |
| `router` | `string` Name of the Router resource to query for Nat Mapping information of VM endpoints. |

### Query parameters

| Parameters ||
|---|---|
| `maxResults` | `integer (https://developers.google.com/discovery/v1/type-format format)` The maximum number of results per page that should be returned. If the number of available results is larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`) |
| `pageToken` | `string` Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list request to get the next page of results. |
| `filter` | `string` A filter expression that filters resources listed in the response. Most Compute resources support two types of filter expressions: expressions that support regular expressions and expressions that follow API improvement proposal [AIP-160](https://google.aip.dev/160). These two types of filter expressions cannot be mixed in one request. If you want to use AIP-160, your expression must specify the field name, an operator, and the value that you want to use for filtering. The value must be a string, a number, or a boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or `:`. For example, if you are filtering Compute Engine instances, you can exclude instances named `example-instance` by specifying `name != example-instance`. The `:*` comparison can be used to test whether a key has been defined. For example, to find all objects with `owner` label use: labels.owner:* You can also filter nested fields. For example, you could specify `scheduling.automaticRestart = false` to include instances only if they are not scheduled for automatic restarts. You can use filtering on nested fields to filter based on [resource labels](https://docs.cloud.google.com/compute/docs/labeling-resources). To filter on multiple expressions, provide each separate expression within parentheses. For example: (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") By default, each expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For example: (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true) If you want to use a regular expression, use the `eq` (equal) or `ne` (not equal) operator against a single un-parenthesized expression with or without quotes or against multiple parenthesized expressions. Examples: `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'` `fieldname eq "double quoted literal"` `(fieldname1 eq literal) (fieldname2 ne "literal")` The literal value is interpreted as a regular expression using Google [RE2](https://github.com/google/re2/wiki/Syntax) library syntax. The literal value must match the entire field. For example, to filter for instances that do not end with name "instance", you would use `name ne .*instance`. You cannot combine constraints on multiple fields using regular expressions. |
| `orderBy` | `string` Sorts list results by a certain order. By default, results are returned in alphanumerical order based on the resource name. You can also sort results in descending order based on the creation timestamp using `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse chronological order (newest result first). Use this to sort resources like operations so that the newest operation is returned first. Currently, only sorting by `name` or `creationTimestamp desc` is supported. |
| `returnPartialSuccess` | `boolean` Opt-in for partial success behavior which provides partial results in case of failure. The default value is false. For example, when partial success behavior is enabled, aggregatedList for a single zone scope either returns all resources in the zone or no resources, with an error code. |
| `natName` | `string` Name of the nat service to filter the Nat Mapping information. If it is omitted, all nats for this router will be returned. Name should conform to RFC1035. |

### Request body

The request body must be empty.

### Response body

Contains a list of VmEndpointNatMappings.

If successful, the response body contains data with the following structure:

| JSON representation |
|---|
| ``` { "kind": string, "id": string, "result": [ { "instanceName": string, "interfaceNatMappings": [ { "sourceVirtualIp": string, "sourceAliasIpRange": string, "numTotalNatPorts": integer, "natIpPortRanges": [ string ], "drainNatIpPortRanges": [ string ], "numTotalDrainNatPorts": integer, "ruleMappings": [ { "ruleNumber": integer, "numTotalNatPorts": integer, "natIpPortRanges": [ string ], "drainNatIpPortRanges": [ string ], "numTotalDrainNatPorts": integer } ] } ] } ], "nextPageToken": string, "selfLink": string, "warning": { "code": enum, "message": string, "data": [ { "key": string, "value": string } ] } } ``` |

| Fields ||
|---|---|
| `kind` | `string` Output only. Type of resource. Always `compute#vmEndpointNatMappingsList` for lists of Nat mappings of VM endpoints. |
| `id` | `string` Output only. The unique identifier for the resource. This identifier is defined by the server. |
| `result[]` | `object` Output only. A list of Nat mapping information of VM endpoints. |
| `result[].instanceName` | `string` Output only. Name of the VM instance which the endpoint belongs to |
| `result[].interfaceNatMappings[]` | `object` |
| `result[].interfaceNatMappings[].sourceVirtualIp` | `string` Output only. Primary IP of the VM for this NIC. |
| `result[].interfaceNatMappings[].sourceAliasIpRange` | `string` Output only. Alias IP range for this interface endpoint. It will be a private (RFC 1918) IP range. Examples: "10.33.4.55/32", or "192.168.5.0/24". |
| `result[].interfaceNatMappings[].numTotalNatPorts` | `integer` Output only. Total number of ports across all NAT IPs allocated to this interface. It equals to the aggregated port number in the field natIpPortRanges. |
| `result[].interfaceNatMappings[].natIpPortRanges[]` | `string` Output only. A list of all IP:port-range mappings assigned to this interface. These ranges are inclusive, that is, both the first and the last ports can be used for NAT. Example: \["2.2.2.2:12345-12355", "1.1.1.1:2234-2234"\]. |
| `result[].interfaceNatMappings[].drainNatIpPortRanges[]` | `string` Output only. routers.list of all drain IP:port-range mappings assigned to this interface. These ranges are inclusive, that is, both the first and the last ports can be used for NAT. Example: \["2.2.2.2:12345-12355", "1.1.1.1:2234-2234"\]. |
| `result[].interfaceNatMappings[].numTotalDrainNatPorts` | `integer` Output only. Total number of drain ports across all NAT IPs allocated to this interface. It equals to the aggregated port number in the field drainNatIpPortRanges. |
| `result[].interfaceNatMappings[].ruleMappings[]` | `object` Output only. Information about mappings provided by rules in this NAT. |
| `result[].interfaceNatMappings[].ruleMappings[].ruleNumber` | `integer` Output only. Rule number of the NAT Rule. |
| `result[].interfaceNatMappings[].ruleMappings[].numTotalNatPorts` | `integer` Output only. Total number of ports across all NAT IPs allocated to this interface by this rule. It equals the aggregated port number in the field natIpPortRanges. |
| `result[].interfaceNatMappings[].ruleMappings[].natIpPortRanges[]` | `string` Output only. A list of all IP:port-range mappings assigned to this interface by this rule. These ranges are inclusive, that is, both the first and the last ports can be used for NAT. Example: \["2.2.2.2:12345-12355", "1.1.1.1:2234-2234"\]. |
| `result[].interfaceNatMappings[].ruleMappings[].drainNatIpPortRanges[]` | `string` Output only. routers.list of all drain IP:port-range mappings assigned to this interface by this rule. These ranges are inclusive, that is, both the first and the last ports can be used for NAT. Example: \["2.2.2.2:12345-12355", "1.1.1.1:2234-2234"\]. |
| `result[].interfaceNatMappings[].ruleMappings[].numTotalDrainNatPorts` | `integer` Output only. Total number of drain ports across all NAT IPs allocated to this interface by this rule. It equals the aggregated port number in the field drainNatIpPortRanges. |
| `nextPageToken` | `string` Output only. This token allows you to get the next page of results for list requests. If the number of results is larger than `maxResults`, use the `nextPageToken` as a value for the query parameter `pageToken` in the next list request. Subsequent list requests will have their own `nextPageToken` to continue paging through the results. |
| `selfLink` | `string` Output only. Server-defined URL for this resource. |
| `warning` | `object` Output only. Informational warning message. |
| `warning.code` | `enum` Output only. A warning code, if applicable. For example, Compute Engine returns `NO_RESULTS_ON_PAGE` if there are no results in the response. |
| `warning.message` | `string` Output only. A human-readable description of the warning code. |
| `warning.data[]` | `object` Output only. Metadata about this warning in `key: value` format. For example: ```html "data": [  {  "key": "scope",  "value": "zones/us-east1-d"  }] ``` <br /> |
| `warning.data[].key` | `string` Output only. A key that provides more detail on the warning being returned. For example, for warnings where there are no results in a list request for a particular zone, this key might be `scope` and the key value might be the zone name. Other examples might be a key indicating a deprecated resource and a suggested replacement, or a warning about invalid network settings (for example, if an instance attempts to perform IP forwarding but is not enabled for IP forwarding). |
| `warning.data[].value` | `string` Output only. A warning data value corresponding to the key. |

### Authorization scopes

Requires one of the following OAuth scopes:

- `https://www.googleapis.com/auth/compute.readonly`
- `
  https://www.googleapis.com/auth/compute`
- `
  https://www.googleapis.com/auth/cloud-platform`

For more information, see the [Authentication Overview](https://docs.cloud.google.com/docs/authentication#authorization-gcp).

### IAM Permissions

In addition to any permissions specified on the fields above, authorization requires one or more of the following [IAM](https://cloud.google.com/iam/docs/) permissions:

- `compute.routers.get`

To find predefined roles that contain those permissions, see [Compute Engine IAM Roles](https://docs.cloud.google.com/compute/docs/access/iam).